.TL
wdfs - A webdav filesystem client
.AU
Steve Simon
.AB
The design and implementation of a webdav filesystem client for plan9 is described
together with current work to improve its perceived performance and possible future
changes to the same end.
.AE
.NH
Introduction
.LP
Webdav 
.[
RFC4918
.]
is a widely implemented protocol about which there was a flurry of excitment
in the late 1990s, the hope was that it would become a standard for HTML authoring
and, with the addition of DeltaV
.[
RFC3253
.]
, version control.
.LP
The standard has now stabalised and is widely available under most COTS OSs; A webdav
server is even available onplan9 using the Pegasus HTTP server.
.LP
Webdav uses an extended form of the HTTP protocol to send small XML snippets
describing the transaction required, thus any plan9 webdav impmentation will need
an XML 
.[
XML
.]
parser.
.NH 2
Xml parser
.PP
A DOM model XML parser was written for another project and adapted to the interfaces
needed for this project. Dom model parsers read the xml file into linked data structures
in memory and need only one pass over the data source. The parser is complete and appears
compliant. The DOM model means the parsed XML is fast and easy to parse as
the XML level lexical analysis is complete, the disadvantage of this design
is the the load it puts on the malloc library.
.PP
The XML parser accepts standard entinty references, PCDATA, attributes and values,
and preserves the element heirarchy. Comments are elided and there is basic support
for XML namespaces. It does not currently support PCDATA as the author has never had
the need for it.
.LP
Another project where this XML library was used found the demands on the malloc
allocator excessive and a seperate scheme was devised using a reference counted
binary tree for recurrant strings such as attribute names and a simple heap for
unique strings, such as attribute values. This greatly reduced the memory and
cpu load during parsing, though with hindsight a different parse model should
have been adopted (such as SOX).
.NH
Webfs extensions
.LP
Webfs(1) had to be modified in order to:
.DS
• Support the new WebDav message types
• Expose more HTTP header information
• Improve webfs's authentication coverage (digest added so far)
• Support chunked encoding, used by many WebDav servers
.DE
Every attempt was made to do this in a sympathetic maner but it is still not clear to me
wether the design of webfs is elegant or ugly.
.NH
9P file server
.LP
A fairly traditional multithreaded file server was written based on the lib9p library
in the plan9 distribution. This uses the XML parsing library and webfs(1) the plan9 HTTP
client application; This part of the system present little difficulties.
.NH
Webdav protocol variations
.LP
As wdfs(1) was tested against more servers it soon became appearant that the WebDav
protocol is not as detailed as one might like. Simple attributes may be supported
differently on each server - for example a readonly flag on a file, and others only
appear when the server is in a specific mode (MicroSoft™ SharePoint). As a result
webfs(1) always to provides a reasonable minimum feature set - reporting file ownership,
readonly flags and, last access times - extending this to other metadata where available.
.LP
The most disappointing variation was the inability of some servers to support GET or
PUT methods with a range specification. This means that files must be fetched into
a local temp area before they maybe read or modified and the entire file must be sent
when writing the file. This is an onerous requirment when the file in question is large. 
As we pay such a performance penalty for this missing feature on some servers a command
line option is available to enable partial writes or reads (usinga range specifier) where
they are supported.
.NH
Performance enhancement.
.LP
The performance of webfs(1) can appear fair for local file servers or dreadful for remote
or slow ones, there are several reasons for this.
.TI
RTT
.br
Large roundtrip times slow remote filesystem response. One solution is top merge where
possible, currently this is not done and a walk to a deep directory will generate
a transaction for each pathname component. A simple improvment would be to send a walk
as a single transaction - implementing the walk() interface to lib9p rather than walk1().
.TI
Readahead
.br
readahead could be used to asynchronously transfer more of a files contents when
only a small amount has been requested in the traditional manner. This is already
done to the extent of rounding up transfers to 8Kbytes and serving reads from a
local buffer. This technique could be extended to requesting a directory scan of
the terminal directory of a walk, in the hope that it might be needed.
.TI
Caching
.br
A volatile local metdata cache of walks and directory scans has already been added
and has improved the perceived performance of the server significantly. This implements
a published algorithm which uses knowledge of the last modified time of the object
to predict its cache occupancy time
.[
Alex
.]
.R .
.TI
gzip content-encoding
.br
Currently compressed encoding schemes are not supported by webfs(1), these could
improve response when faced with low bandwith connections, though this is less of
a problem these days and so it was not considered a priority.
.TI
persistent HTTP connections
.br
we need them
.NH
Applications
.LP
The author has found several applications for wdfs(1) in his daily life,
as a readonly SVN client - a webdav server is part of every SVN installation
and it appears that it is enabled without exception.
.LP
Several cloud storage providers,
.[
box.net
.]
.[
mydrive.com
.]
offer webdav to access their storage, many allow users free access to a few Gbytes
which the author uses to keep his venti scores.
.LP
... unfinished...