#include <u.h>
#include <libc.h>
#include <fcall.h>
#include <thread.h>
#include <9p.h>
#include <libsec.h>
#include <ctype.h>
#include <flate.h>
#include <bio.h>
#include <xml.h>
#include "wdfs.h"

int
exch(Session *s, Param *prm, void *tx, int ntx, int txfd)
{
	int n, rc, fd, e;
	char *a[4], err[ERRMAX], buf[8192];

	snprint(buf, sizeof buf, "%s/%d/ctl", s->webfs, s->conid);
	if((fd = open(buf, OWRITE)) < 0)
		return -1;

	for(; prm && prm->name; prm++)
		if(strcmp(prm->name, "url") == 0)
			fprint(fd, "%s %s%s", prm->name, s->base, prm->value);
		else
			fprint(fd, "%s %s", prm->name, prm->value);
	close(fd);

	if(tx || txfd != -1){
		snprint(buf, sizeof buf, "%s/%d/postbody", s->webfs, s->conid);
		fd = open(buf, OWRITE);
		assert(fd != -1);
		if(tx){
			if(ntx <= 0)
				ntx = strlen(tx);
			write(fd, tx, ntx);
		}
		if(txfd != -1){
			seek(txfd, 0LL, 0);
			while((n = read(txfd, buf, sizeof(buf))) > 0)
				assert(write(fd, buf, n) == n);
		}
		close(fd);
	}

	snprint(buf, sizeof buf, "%s/%d/body", s->webfs, s->conid);
	rc = open(buf, OREAD);

	rerrstr(err, sizeof(err));
	if(tokenize(err, a, nelem(a)) >= 2)
		if((e = atoi(a[1])) > 0)
			httperrstr(e);

	return rc;
}

int
contentlength(Session *s)
{
	int n, fd;
	char buf[8192];

	snprint(buf, sizeof buf, "%s/%d/contentlength", s->webfs, s->conid);
	if((fd = open(buf, OREAD)) < 0)
		return -1;
	n = read(fd, buf, sizeof(buf)-1);
	close(fd);

	if(n < 0)
		return -1;
	buf[n] = 0;
	return atoi(buf);
}


