.TH WDFS 1
.SH NAME
wdfs \- WebDAV file protocol client
.SH SYNOPSIS
.B wdfs
[
.B -p part
] [
.B -m mnt
] [
.B -s srv
] [
.B -w webfs-dir
]
.I host 
.SH DESCRIPTION
.I wdfs
starts a 9p server which mounts itself on the directory specified
by the
.B -m
option, or /n/wdfs by default. If an srv name is specified with the
.B -s
option then a file descriptor will be posted in /srv with the given name.
Normally wdfs uses the filesystem provided by
.I webfs(1)
at /mnt/web, however an alternative mountpoint may be specified with the
.B -w
option.
.sp 1
Some WebDAV servers support HTTP Range: specifiers on GET and PUT commands, this can improve
perceived performance of wdfs which will otherwise have transfer much more data than
expected. Sadly these methods are not widely supported so they are disabled by default.
They may be enabled using the
.B -p
option specifiying the words
.B put
or
.B get
to enable partial transfers of the revelant type; the option may be repeated to enable
both.
.sp 1
.I wdfs
contains a crude metadata cache which holds retrieved directory information for a maximum
of ten secconds.
.SH SVN
SVN repositories are generally configured to expose their contents as a WebDAV filesystem.
.I wdfs(1)
can mount these, mapping the user ID of the creator of the file
or directory, and the group ID to the current revision number of the object.
.P
It may be necessary to specify the repository name withing the server
as SVN servers do not, by default, expose a root directory to WebDAV.
.P
Enabling the 'svnParentPath' configuration option in the
SVN server will cause it to generate an XHTML
root directory listing the repositories offered by the server.
.IR wdfs (1)
will make a special attempt to fetch and parse this if it
cannot get a normal WebDAV root directory from the server.
.SH EXAMPLES
.nj
.nf
.CW
# Start webfs if it is not already running
	webfs

# Connect to apache's SVN repository
	wdfs -m /n/apache https://svn.apache.org/repos/asf

# Connect to box.net's free webdav cloud storage (you must signup first)
	wdfs -m /n/box -p get https://www.box.net/dav
\fR
.fi
.ju
.SH SOURCE
.B /sys/src/cmd/wdfs.c
.SH SEE ALSO
.IR libxml (2),
.br
.IR webfs (2),
.br
.I http://www.webdav.org
.SH BUGS
The cache should be much smarter
.sp 1
It should be possible to extend
.I wdfs
to create an full svn client, currently 
it presents mearly a readonly view of the repository.
.sp 1
Server support for last modified date, 
creator ID, and the readonly and executable flags are patchy at best. 
